/* Problem URL: https://codeforces.com/problemset/problem/1858/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, m, d;
    cin >> n >> m >> d;

    vi t(m);
    cin >> t;

    vl suf(m);
    suf[m - 1] = (n - t[m - 1]) / d + 1;

    for (int i = m - 2; i >= 0; i--) {
        suf[i] = suf[i + 1] + (t[i + 1] - t[i] - 1) / d + 1;
    }

    ll ans = OO;
    int c = 1;
    ll pref = 0;

    rep(i, m) {
        if (i == 0) {
            ll tot = (t[i + 1] - 2) / d + suf[1] + 1;
            ans = tot;
            pref += max((t[i] - 2) / d, 0) + 1 + (t[0] != 1);
            continue;
        }

        if (i == m - 1) {
            ll tot = (n - t[i - 1]) / d + pref;

            if (tot < ans) {
                ans = tot;
                c = 1;
                continue;
            }

            if (tot == ans) {
                c++;
            }

            continue;
        }

        ll tot = (t[i + 1] - t[i - 1] - 1) / d + suf[i + 1] + pref;
        if (tot < ans) {
            ans = tot;
            c = 1;
        } else if (tot == ans) {
            c++;
        }

        pref += (t[i] - t[i - 1] - 1) / d + 1;
    }

    cout << ans << ' ' << c << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
